<?php
 
class myDbDateCompareValidator extends sfValidator
{

  public function initialize($context, $parameters = null)
  {
    // initialize parent
    parent::initialize($context, $parameters);
 
    // set defaults
    $this->setParameter('date_error', 'Invalid date');
 
    $this->getParameterHolder()->add($parameters);
 
    return true;
  }
 
  
  /*
   * Validate function that compare that it is possible to include a new date in
   * some conditions.
   * The date passed by $value is searched in the table 'class_name'.
   * The table must have a colum called 'column_filter', and the validator only
   * will compare with the fields that have in this column 'column_value'.
   * To get the true answer 
   * (and can execute without error) there must not be any field of the column
   * 'column' that can be find using the search_type 
   * Value: first comparison element
   * Params needed:
   * +class_name: The class where the date is stored
   * +date_db: the date column name to compare in the db table
   * +date_php: the date to compare name in php class
   * +found_error: the error message to return to the user
   * +search_type: This is the condition to return false.
   *  Posible values for search_type (without colomns):
   *    'NOT_EQUAL'
   *    'GREATER_THAN'
   *    'LESS_THAN'
   *    'GREATER_EQUAL'
   *    'LESS_EQUAL'
   *    Empty value is Equal
   * -exception_id: if there is an exception row in the table (Example: in 
   *  edition the row edited), it takes the field of the form which contains it)
   * -criteria: some additional criteria for propel selection. This aditional 
   *  criteria must be noted this way:
   * criteria:
   *  criteria1:
   *    +column: column name for criteria checking
   *    *value: value for criteria
   *    *field: field of the form where the value is defined
   *    -criteria: criteria pattern (see symfony or propel documentation)
   * 
   */
  public function execute(&$value, &$error)
  {
 
    //obtain the culture for the operations       
    $culture = $this->getContext()->getUser()->getCulture();
    
    //Recover table name and checked columns
    $className = $this->getParameter('class_name');
    $dateDb = $this->getParameter('date_db');
    $datePHP= $this->getParameter('date_php');
   
    //recover data from the form
    $date = $value;
    if($this->getParameter('exception_id')){
      $exceptionIdField= $this->getParameter('exception_id');
      $exceptionId=$this->getContext()->getRequest()->getParameter($exceptionIdField);
    }

    //transforming the dates to MySQL format
    list($d, $m, $y) = sfI18N::getDateForCulture($date, $culture);
    $date = strtotime("$y-$m-$d 00:00");
    
    
    //get the search type
    if($this->getParameter('search_type')){
      $search=$this->getParameter('search_type');
    }
    
    //defining the common search criteria
    
    $c= new Criteria();
    if($this->getParameter('criteria')){
      foreach($this->getParameter('criteria') as $criteria){
        if(isset($criteria['field'])){
          if(isset($criteria['criteria'])){
            eval ('$c->add('.$className.'Peer::'.$criteria['column'].', '.$this->getContext()->getRequest()->getParameter($criteria['field']).', '.$criteria['criteria'] .');');
          }else{
            eval ('$c->add('.$className.'Peer::'.$criteria['column'].', '.$this->getContext()->getRequest()->getParameter($criteria['field']).');');
          }
        }else{
          if(isset($criteria['criteria'])){
            eval ('$c->add('.$className.'Peer::'.$criteria['column'].', '.$criteria['value'].', '.$criteria['criteria'] .');');
          }else{
            eval ('$c->add('.$className.'Peer::'.$criteria['column'].', '.$criteria['value'].');');
          }
        }
      }
    }
    if($this->getParameter('exception_id')){
      eval ('$c->add('.$className.'Peer::ID, '.$exceptionId.', Criteria::NOT_EQUAL);');
    }
    
    //checking
    if($this->getParameter('search_type')){
      eval ('$c->add('.$className.'Peer::'.$dateDb.', '.$date.', Criteria::'.$search.');');
    }else{
      eval ('$c->add('.$className.'Peer::'.$dateDb.', '.$date.');');
    }
    eval ('$foundDate= '.$className.'Peer::doSelectOne($c);');
    
    
    //determine the result
    if ($foundDate){
      $format = 'd';
      $dateFormats[$culture] = new sfDateFormat($culture);
      $charset = sfConfig::get('sf_charset');
      eval('$returnDate= $dateFormats[$culture]->format($foundDate->get'.$datePHP.'(), $format, null, $charset);');
      $error = $this->getContext()->getI18N()->__($this->getParameter('found_error')).' '.$returnDate;
      return false;
    }
    return true;
  }
   /* 
    if($foundDate){
      $error = $this->getContext()->getI18N()->__($this->getParameter('start_date_error_message')).' '.$foundPeriod1;
      return false;
    }  
    
    //prepare except value if it is neccesary
    
    if( $this->getParameter('except_column')&&$this->getParameter('except_value')){
	    $exceptColumn= $this->getParameter('except_column');
	    $exceptValueParam= $this->getParameter('except_value');
	    $exceptValue= $this->getContext()->getRequest()->getParameter($exceptValueParam);
    }
    
    //Search one row tha raises the conditions
    $c = new Criteria();
    eval('$c->add('.$class.'Peer::'.$columnFilter.', '.$columnValue.');');
    eval('$c->add('.$class.'Peer::'.$column.', '.$date.', Criteria::'.$search.');');
    if($this->getParameter('except_column')&&$this->getParameter('except_value')){
      eval('$c->add('.$class.'Peer::'.$exceptColumn.', '.$exceptValue.', Criteria::NOT_EQUAL);');
    }
    eval('$foundDate = '.$class.'Peer::doSelectOne($c);');

    //determine the result
    
    if ($foundDate){
    	$format = 'd';
    	$dateFormats[$culture] = new sfDateFormat($culture);
	    $charset = sfConfig::get('sf_charset');
    	eval('$returnDate= $dateFormats[$culture]->format($foundDate->get'.$phpColumn.'(), $format, null, $charset);');
      $error = $this->getContext()->getI18N()->__($this->getParameter('found_error')).' '.$returnDate;
      return false;
    }
    return true;
  }*/
}