<?php
 
class myLoginValidator extends sfValidator
{

  public function initialize($context, $parameters = null)
  {
    // initialize parent
    parent::initialize($context);
 
    // set defaults
    $this->setParameter('login_error', 'Invalid input');
 
    $this->getParameterHolder()->add($parameters);
 
    return true;
  }
  
  /*
   * Validate function that checks the name and password of an user to login
   * Value: nickname for the user
   * Param needed:
   *  password: the password to verify
   *  login_error: the error message to send the controler and inform the user
   * 
   */
 
  public function execute(&$value, &$error)
  {
  	//obtaining the password and the user name from the parameters
    $password_param = $this->getParameter('password');
    $password = $this->getContext()->getRequest()->getParameter($password_param);
    $login = $value;
 
    // anonymous is not a real user
    if ($login == 'anonymous')
    {
      $error = $this->getParameter('login_error');
      return false;
    }
 
    //search the user with this name
    $c = new Criteria();
    $c->add(UserPeer::NICKNAME, $login);
    $user = UserPeer::doSelectOne($c);
 
    // does nickname exists?
    if ($user)
    {
      // is password OK?
      if (sha1($user->getSalt().$password) == $user->getSha1Password())
      {
		    $this->getContext()->getUser()->signIn($user);
        return true;
      }
    }
 
    $error = $this->getParameter('login_error');
    return false;
  }
}