<?php
// auto-generated by sfPropelCrud
// date: 2008/11/25 17:23:50
?>
<?php

/**
 * season actions.
 *
 * @package    gesport
 * @subpackage season
 * @author     Diego Cebrián Martínez
 * @version    SVN: $Id: actions.class.php 3335 2007-01-23 16:19:56Z fabien $
 */
class seasonActions extends sfActions
{
  public function executeIndex()
  {
    return $this->forward('season', 'list');
  }

  public function executeList()
  {
    $this->seasons = SeasonPeer::doSelect(new Criteria());
  }

  public function executeShowCurrent()
  {
    $this->season = SeasonPeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->season);
    $this->macrocycle = MacrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->user = $this->season->getUser();
    $this->forward404Unless($this->user);
    $this->forwardIf($this->season->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->setTemplate('show');
  }

  public function executeShow()
  {
    $this->season = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id')); 
    $this->forward404Unless($this->season);
    $this->macrocycle = MacrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->user = $this->season->getUser(); 
    $this->forward404Unless($this->user);
    $this->forwardIf($this->season->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
  }
/*
 * Original method to create Seasons. Created Add because many parameters are predefined
  public function executeCreate()
  {
    $this->season = new Season();

    $this->setTemplate('edit');
  }
*/
  public function executeEdit()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
    	//retrieve data for the form
	    $this->season = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
	    $this->forward404Unless($this->season);
	    $this->user = $this->season->getUser();
      $this->forward404Unless($this->user);
      //access control
	    $this->forwardIf($this->season->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
	    
      // display the form
      $this->form_action="season_edit";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());
      
	    return sfView::SUCCESS;
    }
    //Recover data and update the season
    else
    {
      $this->season = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
      $this->forward404Unless($this->season);
      $this->user = $this->season->getUser();
      $this->forward404Unless($this->user);
      //access control
      $this->forwardIf($this->season->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      //update and save
      $season=$this->update($this->season);
      $season->save();
      
      //redirect to selected page
      $this->redirect('@athlete_show?id='.$this->user->getId().'&season='.$season->getId());
    }
  }
  
  public function handleErrorEdit()
  {
    
  	$this->season = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
  	$this->forward404Unless($this->season);
  	$this->user = $this->season->getUser();
  	$this->forward404Unless($this->user);
  	//access control
  	$this->forwardIf($this->season->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    $this->season->setDescription($this->getRequestParameter('description'));
    $this->season->setUserId($this->getRequestParameter('user_id') ? $this->getRequestParameter('user_id') : null);
    $this->season->setTheoricIntensity($this->getRequestParameter('theoric_intensity'));
    $this->season->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }

  public function executeDelete()
  {

    $this->season = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
    $this->forward404Unless($this->season);
    $this->user = $this->season->getUser();
    $this->forward404Unless($this->user);
    //access control
    $this->forwardIf($this->season->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    try{
	    $this->season->delete();
	    return $this->redirect('@seasons_athlete?user_id='.$user_id);
    }
    //if the user is used in other class, advert that can't be deleted
    catch (PropelException $e){
      $this->macrocycle = MacrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
      $this->message = ' is still used in Gesport and can not be deleted.';
      $this->setTemplate('notDeleted');  
    }
    catch (Exception $e){
      $this->macrocycle = MacrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
      $this->message = ' cannot be deleted.';
      $this->setTemplate('notDeleted'); 
    }
  }
  
  //Creation and editing from Coach View
  public function executeAdd()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->season = new Season();
      $this->forward404Unless($this->season);
      
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      // display the form
      $this->form_action="season_add";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the season
    else
    {
      // handle the form submission
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      $this->season = new Season();
      $this->forward404Unless($this->season);   
      $season=$this->update($this->season);
        
      $season->save();
      
      // redirect to the page of the user
      return $this->redirect('@athlete_show?id='.$this->user->getId().'&season='.$season->getId());
    }
  }
  
  public function handleErrorAdd()
  {
    $this->user =  UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->season = new Season();
    $this->forward404Unless($this->user);
    $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    $this->forward404Unless($this->season);
    $this->season->setDescription($this->getRequestParameter('description'));
    $this->season->setUserId($this->getRequestParameter('user_id') ? $this->getRequestParameter('user_id') : null);
    $this->season->setTheoricIntensity($this->getRequestParameter('theoric_intensity'));
    $this->season->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }

  public function executeMyAthlete()
  {
    $c=new Criteria();
    $c->add(SeasonPeer::USER_ID, $this->getRequestParameter('user_id'));
    $this->seasons = SeasonPeer::doSelect($c);
    $this->user =  UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->user);
    $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
  }
  
  protected function update($season){
    $season->setDescription($this->getRequestParameter('description'));
    if ($this->getRequestParameter('start_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('start_at'), $this->getUser()->getCulture());
      $season->setStartAt("$y-$m-$d");
    }
    if ($this->getRequestParameter('last_day_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('last_day_at'), $this->getUser()->getCulture());
      $season->setLastDayAt("$y-$m-$d");
    }
    $season->setUserId($this->getRequestParameter('user_id') ? $this->getRequestParameter('user_id') : null);
    $season->setTheoricIntensity($this->getRequestParameter('theoric_intensity'));
    $season->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return $season;
  }
}
