<?php



class CategoryMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.CategoryMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('category');
		$tMap->setPhpName('Category');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DESCRIPTION', 'Description', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addColumn('START_AT', 'StartAt', 'string', CreoleTypes::VARCHAR, false, null);

		$tMap->addColumn('END_AT', 'EndAt', 'string', CreoleTypes::VARCHAR, false, null);

		$tMap->addColumn('MALE', 'Male', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addForeignKey('EVENT_ID', 'EventId', 'int', CreoleTypes::INTEGER, 'event', 'ID', false, null);

		$tMap->addForeignKey('CIRCUIT_ID', 'CircuitId', 'int', CreoleTypes::INTEGER, 'circuit', 'ID', false, null);

		$tMap->addForeignKey('PRICE_ID', 'PriceId', 'int', CreoleTypes::INTEGER, 'price', 'ID', false, null);

		$tMap->addColumn('NO_COMPETITIVE', 'NoCompetitive', 'boolean', CreoleTypes::BOOLEAN, false, null);

	} 
} 