<?php


abstract class BaseSeason extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $start_at;


	
	protected $last_day_at;


	
	protected $user_id;


	
	protected $theoric_intensity;


	
	protected $theoric_volume;


	
	protected $reported_intensity;


	
	protected $reported_volume;

	
	protected $aUser;

	
	protected $collMacrocycles;

	
	protected $lastMacrocycleCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getStartAt($format = 'Y-m-d')
	{

		if ($this->start_at === null || $this->start_at === '') {
			return null;
		} elseif (!is_int($this->start_at)) {
						$ts = strtotime($this->start_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [start_at] as date/time value: " . var_export($this->start_at, true));
			}
		} else {
			$ts = $this->start_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getLastDayAt($format = 'Y-m-d')
	{

		if ($this->last_day_at === null || $this->last_day_at === '') {
			return null;
		} elseif (!is_int($this->last_day_at)) {
						$ts = strtotime($this->last_day_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [last_day_at] as date/time value: " . var_export($this->last_day_at, true));
			}
		} else {
			$ts = $this->last_day_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getUserId()
	{

		return $this->user_id;
	}

	
	public function getTheoricIntensity()
	{

		return $this->theoric_intensity;
	}

	
	public function getTheoricVolume()
	{

		return $this->theoric_volume;
	}

	
	public function getReportedIntensity()
	{

		return $this->reported_intensity;
	}

	
	public function getReportedVolume()
	{

		return $this->reported_volume;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = SeasonPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = SeasonPeer::DESCRIPTION;
		}

	} 
	
	public function setStartAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [start_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->start_at !== $ts) {
			$this->start_at = $ts;
			$this->modifiedColumns[] = SeasonPeer::START_AT;
		}

	} 
	
	public function setLastDayAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [last_day_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->last_day_at !== $ts) {
			$this->last_day_at = $ts;
			$this->modifiedColumns[] = SeasonPeer::LAST_DAY_AT;
		}

	} 
	
	public function setUserId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = SeasonPeer::USER_ID;
		}

		if ($this->aUser !== null && $this->aUser->getId() !== $v) {
			$this->aUser = null;
		}

	} 
	
	public function setTheoricIntensity($v)
	{

		if ($this->theoric_intensity !== $v) {
			$this->theoric_intensity = $v;
			$this->modifiedColumns[] = SeasonPeer::THEORIC_INTENSITY;
		}

	} 
	
	public function setTheoricVolume($v)
	{

		if ($this->theoric_volume !== $v) {
			$this->theoric_volume = $v;
			$this->modifiedColumns[] = SeasonPeer::THEORIC_VOLUME;
		}

	} 
	
	public function setReportedIntensity($v)
	{

		if ($this->reported_intensity !== $v) {
			$this->reported_intensity = $v;
			$this->modifiedColumns[] = SeasonPeer::REPORTED_INTENSITY;
		}

	} 
	
	public function setReportedVolume($v)
	{

		if ($this->reported_volume !== $v) {
			$this->reported_volume = $v;
			$this->modifiedColumns[] = SeasonPeer::REPORTED_VOLUME;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->start_at = $rs->getDate($startcol + 2, null);

			$this->last_day_at = $rs->getDate($startcol + 3, null);

			$this->user_id = $rs->getInt($startcol + 4);

			$this->theoric_intensity = $rs->getFloat($startcol + 5);

			$this->theoric_volume = $rs->getFloat($startcol + 6);

			$this->reported_intensity = $rs->getFloat($startcol + 7);

			$this->reported_volume = $rs->getFloat($startcol + 8);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 9; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Season object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SeasonPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			SeasonPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SeasonPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) {
					$affectedRows += $this->aUser->save($con);
				}
				$this->setUser($this->aUser);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SeasonPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += SeasonPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collMacrocycles !== null) {
				foreach($this->collMacrocycles as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aUser !== null) {
				if (!$this->aUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUser->getValidationFailures());
				}
			}


			if (($retval = SeasonPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collMacrocycles !== null) {
					foreach($this->collMacrocycles as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SeasonPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getStartAt();
				break;
			case 3:
				return $this->getLastDayAt();
				break;
			case 4:
				return $this->getUserId();
				break;
			case 5:
				return $this->getTheoricIntensity();
				break;
			case 6:
				return $this->getTheoricVolume();
				break;
			case 7:
				return $this->getReportedIntensity();
				break;
			case 8:
				return $this->getReportedVolume();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SeasonPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getStartAt(),
			$keys[3] => $this->getLastDayAt(),
			$keys[4] => $this->getUserId(),
			$keys[5] => $this->getTheoricIntensity(),
			$keys[6] => $this->getTheoricVolume(),
			$keys[7] => $this->getReportedIntensity(),
			$keys[8] => $this->getReportedVolume(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SeasonPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setStartAt($value);
				break;
			case 3:
				$this->setLastDayAt($value);
				break;
			case 4:
				$this->setUserId($value);
				break;
			case 5:
				$this->setTheoricIntensity($value);
				break;
			case 6:
				$this->setTheoricVolume($value);
				break;
			case 7:
				$this->setReportedIntensity($value);
				break;
			case 8:
				$this->setReportedVolume($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SeasonPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setStartAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setLastDayAt($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setUserId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setTheoricIntensity($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTheoricVolume($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setReportedIntensity($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setReportedVolume($arr[$keys[8]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(SeasonPeer::DATABASE_NAME);

		if ($this->isColumnModified(SeasonPeer::ID)) $criteria->add(SeasonPeer::ID, $this->id);
		if ($this->isColumnModified(SeasonPeer::DESCRIPTION)) $criteria->add(SeasonPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(SeasonPeer::START_AT)) $criteria->add(SeasonPeer::START_AT, $this->start_at);
		if ($this->isColumnModified(SeasonPeer::LAST_DAY_AT)) $criteria->add(SeasonPeer::LAST_DAY_AT, $this->last_day_at);
		if ($this->isColumnModified(SeasonPeer::USER_ID)) $criteria->add(SeasonPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(SeasonPeer::THEORIC_INTENSITY)) $criteria->add(SeasonPeer::THEORIC_INTENSITY, $this->theoric_intensity);
		if ($this->isColumnModified(SeasonPeer::THEORIC_VOLUME)) $criteria->add(SeasonPeer::THEORIC_VOLUME, $this->theoric_volume);
		if ($this->isColumnModified(SeasonPeer::REPORTED_INTENSITY)) $criteria->add(SeasonPeer::REPORTED_INTENSITY, $this->reported_intensity);
		if ($this->isColumnModified(SeasonPeer::REPORTED_VOLUME)) $criteria->add(SeasonPeer::REPORTED_VOLUME, $this->reported_volume);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SeasonPeer::DATABASE_NAME);

		$criteria->add(SeasonPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setStartAt($this->start_at);

		$copyObj->setLastDayAt($this->last_day_at);

		$copyObj->setUserId($this->user_id);

		$copyObj->setTheoricIntensity($this->theoric_intensity);

		$copyObj->setTheoricVolume($this->theoric_volume);

		$copyObj->setReportedIntensity($this->reported_intensity);

		$copyObj->setReportedVolume($this->reported_volume);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getMacrocycles() as $relObj) {
				$copyObj->addMacrocycle($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SeasonPeer();
		}
		return self::$peer;
	}

	
	public function setUser($v)
	{


		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getId());
		}


		$this->aUser = $v;
	}


	
	public function getUser($con = null)
	{
		if ($this->aUser === null && ($this->user_id !== null)) {
						include_once 'lib/model/om/BaseUserPeer.php';

			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);

			
		}
		return $this->aUser;
	}

	
	public function initMacrocycles()
	{
		if ($this->collMacrocycles === null) {
			$this->collMacrocycles = array();
		}
	}

	
	public function getMacrocycles($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseMacrocyclePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMacrocycles === null) {
			if ($this->isNew()) {
			   $this->collMacrocycles = array();
			} else {

				$criteria->add(MacrocyclePeer::SEASON_ID, $this->getId());

				MacrocyclePeer::addSelectColumns($criteria);
				$this->collMacrocycles = MacrocyclePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(MacrocyclePeer::SEASON_ID, $this->getId());

				MacrocyclePeer::addSelectColumns($criteria);
				if (!isset($this->lastMacrocycleCriteria) || !$this->lastMacrocycleCriteria->equals($criteria)) {
					$this->collMacrocycles = MacrocyclePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMacrocycleCriteria = $criteria;
		return $this->collMacrocycles;
	}

	
	public function countMacrocycles($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseMacrocyclePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(MacrocyclePeer::SEASON_ID, $this->getId());

		return MacrocyclePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addMacrocycle(Macrocycle $l)
	{
		$this->collMacrocycles[] = $l;
		$l->setSeason($this);
	}

} 