<?php


abstract class BaseUnitType extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $global_description;

	
	protected $collUnitTypeI18Ns;

	
	protected $lastUnitTypeI18NCriteria = null;

	
	protected $collUnits;

	
	protected $lastUnitCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getGlobalDescription()
	{

		return $this->global_description;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = UnitTypePeer::ID;
		}

	} 
	
	public function setGlobalDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->global_description !== $v) {
			$this->global_description = $v;
			$this->modifiedColumns[] = UnitTypePeer::GLOBAL_DESCRIPTION;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->global_description = $rs->getString($startcol + 1);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating UnitType object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UnitTypePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			UnitTypePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UnitTypePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UnitTypePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += UnitTypePeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collUnitTypeI18Ns !== null) {
				foreach($this->collUnitTypeI18Ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collUnits !== null) {
				foreach($this->collUnits as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = UnitTypePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collUnitTypeI18Ns !== null) {
					foreach($this->collUnitTypeI18Ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collUnits !== null) {
					foreach($this->collUnits as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UnitTypePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getGlobalDescription();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UnitTypePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getGlobalDescription(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UnitTypePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setGlobalDescription($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UnitTypePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setGlobalDescription($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(UnitTypePeer::DATABASE_NAME);

		if ($this->isColumnModified(UnitTypePeer::ID)) $criteria->add(UnitTypePeer::ID, $this->id);
		if ($this->isColumnModified(UnitTypePeer::GLOBAL_DESCRIPTION)) $criteria->add(UnitTypePeer::GLOBAL_DESCRIPTION, $this->global_description);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UnitTypePeer::DATABASE_NAME);

		$criteria->add(UnitTypePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setGlobalDescription($this->global_description);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getUnitTypeI18Ns() as $relObj) {
				$copyObj->addUnitTypeI18N($relObj->copy($deepCopy));
			}

			foreach($this->getUnits() as $relObj) {
				$copyObj->addUnit($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UnitTypePeer();
		}
		return self::$peer;
	}

	
	public function initUnitTypeI18Ns()
	{
		if ($this->collUnitTypeI18Ns === null) {
			$this->collUnitTypeI18Ns = array();
		}
	}

	
	public function getUnitTypeI18Ns($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseUnitTypeI18NPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUnitTypeI18Ns === null) {
			if ($this->isNew()) {
			   $this->collUnitTypeI18Ns = array();
			} else {

				$criteria->add(UnitTypeI18NPeer::ID, $this->getId());

				UnitTypeI18NPeer::addSelectColumns($criteria);
				$this->collUnitTypeI18Ns = UnitTypeI18NPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(UnitTypeI18NPeer::ID, $this->getId());

				UnitTypeI18NPeer::addSelectColumns($criteria);
				if (!isset($this->lastUnitTypeI18NCriteria) || !$this->lastUnitTypeI18NCriteria->equals($criteria)) {
					$this->collUnitTypeI18Ns = UnitTypeI18NPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUnitTypeI18NCriteria = $criteria;
		return $this->collUnitTypeI18Ns;
	}

	
	public function countUnitTypeI18Ns($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseUnitTypeI18NPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(UnitTypeI18NPeer::ID, $this->getId());

		return UnitTypeI18NPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addUnitTypeI18N(UnitTypeI18N $l)
	{
		$this->collUnitTypeI18Ns[] = $l;
		$l->setUnitType($this);
	}

	
	public function initUnits()
	{
		if ($this->collUnits === null) {
			$this->collUnits = array();
		}
	}

	
	public function getUnits($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseUnitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUnits === null) {
			if ($this->isNew()) {
			   $this->collUnits = array();
			} else {

				$criteria->add(UnitPeer::UNIT_TYPE_ID, $this->getId());

				UnitPeer::addSelectColumns($criteria);
				$this->collUnits = UnitPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(UnitPeer::UNIT_TYPE_ID, $this->getId());

				UnitPeer::addSelectColumns($criteria);
				if (!isset($this->lastUnitCriteria) || !$this->lastUnitCriteria->equals($criteria)) {
					$this->collUnits = UnitPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUnitCriteria = $criteria;
		return $this->collUnits;
	}

	
	public function countUnits($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseUnitPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(UnitPeer::UNIT_TYPE_ID, $this->getId());

		return UnitPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addUnit(Unit $l)
	{
		$this->collUnits[] = $l;
		$l->setUnitType($this);
	}

  public function getCulture()
  {
    return $this->culture;
  }

  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getDescription()
  {
    $obj = $this->getCurrentUnitTypeI18N();

    return ($obj ? $obj->getDescription() : null);
  }

  public function setDescription($value)
  {
    $this->getCurrentUnitTypeI18N()->setDescription($value);
  }

  protected $current_i18n = array();

  public function getCurrentUnitTypeI18N()
  {
    if (!isset($this->current_i18n[$this->culture]))
    {
      $obj = UnitTypeI18NPeer::retrieveByPK($this->getId(), $this->culture);
      if ($obj)
      {
        $this->setUnitTypeI18NForCulture($obj, $this->culture);
      }
      else
      {
        $this->setUnitTypeI18NForCulture(new UnitTypeI18N(), $this->culture);
        $this->current_i18n[$this->culture]->setCulture($this->culture);
      }
    }

    return $this->current_i18n[$this->culture];
  }

  public function setUnitTypeI18NForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addUnitTypeI18N($object);
  }

} 