<?php


abstract class BaseUser extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nickname;


	
	protected $first_name;


	
	protected $last_name;


	
	protected $created_at;


	
	protected $born_at;


	
	protected $is_coach;


	
	protected $is_athlete;


	
	protected $coach_id;


	
	protected $picture_id;


	
	protected $is_admin;


	
	protected $is_male;


	
	protected $email;


	
	protected $sha1_password;


	
	protected $salt;


	
	protected $country;


	
	protected $language;

	
	protected $aUserRelatedByCoachId;

	
	protected $aPicture;

	
	protected $collFeedbackTypes;

	
	protected $lastFeedbackTypeCriteria = null;

	
	protected $collSeasons;

	
	protected $lastSeasonCriteria = null;

	
	protected $collCompetitions;

	
	protected $lastCompetitionCriteria = null;

	
	protected $collCompetitionCompetitors;

	
	protected $lastCompetitionCompetitorCriteria = null;

	
	protected $collUsersRelatedByCoachId;

	
	protected $lastUserRelatedByCoachIdCriteria = null;

	
	protected $collArticles;

	
	protected $lastArticleCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNickname()
	{

		return $this->nickname;
	}

	
	public function getFirstName()
	{

		return $this->first_name;
	}

	
	public function getLastName()
	{

		return $this->last_name;
	}

	
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getBornAt()
	{

		return $this->born_at;
	}

	
	public function getIsCoach()
	{

		return $this->is_coach;
	}

	
	public function getIsAthlete()
	{

		return $this->is_athlete;
	}

	
	public function getCoachId()
	{

		return $this->coach_id;
	}

	
	public function getPictureId()
	{

		return $this->picture_id;
	}

	
	public function getIsAdmin()
	{

		return $this->is_admin;
	}

	
	public function getIsMale()
	{

		return $this->is_male;
	}

	
	public function getEmail()
	{

		return $this->email;
	}

	
	public function getSha1Password()
	{

		return $this->sha1_password;
	}

	
	public function getSalt()
	{

		return $this->salt;
	}

	
	public function getCountry()
	{

		return $this->country;
	}

	
	public function getLanguage()
	{

		return $this->language;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = UserPeer::ID;
		}

	} 
	
	public function setNickname($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nickname !== $v) {
			$this->nickname = $v;
			$this->modifiedColumns[] = UserPeer::NICKNAME;
		}

	} 
	
	public function setFirstName($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->first_name !== $v) {
			$this->first_name = $v;
			$this->modifiedColumns[] = UserPeer::FIRST_NAME;
		}

	} 
	
	public function setLastName($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->last_name !== $v) {
			$this->last_name = $v;
			$this->modifiedColumns[] = UserPeer::LAST_NAME;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = UserPeer::CREATED_AT;
		}

	} 
	
	public function setBornAt($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->born_at !== $v) {
			$this->born_at = $v;
			$this->modifiedColumns[] = UserPeer::BORN_AT;
		}

	} 
	
	public function setIsCoach($v)
	{

		if ($this->is_coach !== $v) {
			$this->is_coach = $v;
			$this->modifiedColumns[] = UserPeer::IS_COACH;
		}

	} 
	
	public function setIsAthlete($v)
	{

		if ($this->is_athlete !== $v) {
			$this->is_athlete = $v;
			$this->modifiedColumns[] = UserPeer::IS_ATHLETE;
		}

	} 
	
	public function setCoachId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->coach_id !== $v) {
			$this->coach_id = $v;
			$this->modifiedColumns[] = UserPeer::COACH_ID;
		}

		if ($this->aUserRelatedByCoachId !== null && $this->aUserRelatedByCoachId->getId() !== $v) {
			$this->aUserRelatedByCoachId = null;
		}

	} 
	
	public function setPictureId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->picture_id !== $v) {
			$this->picture_id = $v;
			$this->modifiedColumns[] = UserPeer::PICTURE_ID;
		}

		if ($this->aPicture !== null && $this->aPicture->getId() !== $v) {
			$this->aPicture = null;
		}

	} 
	
	public function setIsAdmin($v)
	{

		if ($this->is_admin !== $v) {
			$this->is_admin = $v;
			$this->modifiedColumns[] = UserPeer::IS_ADMIN;
		}

	} 
	
	public function setIsMale($v)
	{

		if ($this->is_male !== $v) {
			$this->is_male = $v;
			$this->modifiedColumns[] = UserPeer::IS_MALE;
		}

	} 
	
	public function setEmail($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = UserPeer::EMAIL;
		}

	} 
	
	public function setSha1Password($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->sha1_password !== $v) {
			$this->sha1_password = $v;
			$this->modifiedColumns[] = UserPeer::SHA1_PASSWORD;
		}

	} 
	
	public function setSalt($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->salt !== $v) {
			$this->salt = $v;
			$this->modifiedColumns[] = UserPeer::SALT;
		}

	} 
	
	public function setCountry($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->country !== $v) {
			$this->country = $v;
			$this->modifiedColumns[] = UserPeer::COUNTRY;
		}

	} 
	
	public function setLanguage($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->language !== $v) {
			$this->language = $v;
			$this->modifiedColumns[] = UserPeer::LANGUAGE;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nickname = $rs->getString($startcol + 1);

			$this->first_name = $rs->getString($startcol + 2);

			$this->last_name = $rs->getString($startcol + 3);

			$this->created_at = $rs->getTimestamp($startcol + 4, null);

			$this->born_at = $rs->getString($startcol + 5);

			$this->is_coach = $rs->getBoolean($startcol + 6);

			$this->is_athlete = $rs->getBoolean($startcol + 7);

			$this->coach_id = $rs->getInt($startcol + 8);

			$this->picture_id = $rs->getInt($startcol + 9);

			$this->is_admin = $rs->getBoolean($startcol + 10);

			$this->is_male = $rs->getBoolean($startcol + 11);

			$this->email = $rs->getString($startcol + 12);

			$this->sha1_password = $rs->getString($startcol + 13);

			$this->salt = $rs->getString($startcol + 14);

			$this->country = $rs->getString($startcol + 15);

			$this->language = $rs->getString($startcol + 16);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 17; 
		} catch (Exception $e) {
			throw new PropelException("Error populating User object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UserPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			UserPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(UserPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UserPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aUserRelatedByCoachId !== null) {
				if ($this->aUserRelatedByCoachId->isModified()) {
					$affectedRows += $this->aUserRelatedByCoachId->save($con);
				}
				$this->setUserRelatedByCoachId($this->aUserRelatedByCoachId);
			}

			if ($this->aPicture !== null) {
				if ($this->aPicture->isModified()) {
					$affectedRows += $this->aPicture->save($con);
				}
				$this->setPicture($this->aPicture);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += UserPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collFeedbackTypes !== null) {
				foreach($this->collFeedbackTypes as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collSeasons !== null) {
				foreach($this->collSeasons as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collCompetitions !== null) {
				foreach($this->collCompetitions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collCompetitionCompetitors !== null) {
				foreach($this->collCompetitionCompetitors as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collUsersRelatedByCoachId !== null) {
				foreach($this->collUsersRelatedByCoachId as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collArticles !== null) {
				foreach($this->collArticles as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aUserRelatedByCoachId !== null) {
				if (!$this->aUserRelatedByCoachId->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUserRelatedByCoachId->getValidationFailures());
				}
			}

			if ($this->aPicture !== null) {
				if (!$this->aPicture->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aPicture->getValidationFailures());
				}
			}


			if (($retval = UserPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collFeedbackTypes !== null) {
					foreach($this->collFeedbackTypes as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collSeasons !== null) {
					foreach($this->collSeasons as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collCompetitions !== null) {
					foreach($this->collCompetitions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collCompetitionCompetitors !== null) {
					foreach($this->collCompetitionCompetitors as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collArticles !== null) {
					foreach($this->collArticles as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UserPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNickname();
				break;
			case 2:
				return $this->getFirstName();
				break;
			case 3:
				return $this->getLastName();
				break;
			case 4:
				return $this->getCreatedAt();
				break;
			case 5:
				return $this->getBornAt();
				break;
			case 6:
				return $this->getIsCoach();
				break;
			case 7:
				return $this->getIsAthlete();
				break;
			case 8:
				return $this->getCoachId();
				break;
			case 9:
				return $this->getPictureId();
				break;
			case 10:
				return $this->getIsAdmin();
				break;
			case 11:
				return $this->getIsMale();
				break;
			case 12:
				return $this->getEmail();
				break;
			case 13:
				return $this->getSha1Password();
				break;
			case 14:
				return $this->getSalt();
				break;
			case 15:
				return $this->getCountry();
				break;
			case 16:
				return $this->getLanguage();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UserPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNickname(),
			$keys[2] => $this->getFirstName(),
			$keys[3] => $this->getLastName(),
			$keys[4] => $this->getCreatedAt(),
			$keys[5] => $this->getBornAt(),
			$keys[6] => $this->getIsCoach(),
			$keys[7] => $this->getIsAthlete(),
			$keys[8] => $this->getCoachId(),
			$keys[9] => $this->getPictureId(),
			$keys[10] => $this->getIsAdmin(),
			$keys[11] => $this->getIsMale(),
			$keys[12] => $this->getEmail(),
			$keys[13] => $this->getSha1Password(),
			$keys[14] => $this->getSalt(),
			$keys[15] => $this->getCountry(),
			$keys[16] => $this->getLanguage(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UserPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNickname($value);
				break;
			case 2:
				$this->setFirstName($value);
				break;
			case 3:
				$this->setLastName($value);
				break;
			case 4:
				$this->setCreatedAt($value);
				break;
			case 5:
				$this->setBornAt($value);
				break;
			case 6:
				$this->setIsCoach($value);
				break;
			case 7:
				$this->setIsAthlete($value);
				break;
			case 8:
				$this->setCoachId($value);
				break;
			case 9:
				$this->setPictureId($value);
				break;
			case 10:
				$this->setIsAdmin($value);
				break;
			case 11:
				$this->setIsMale($value);
				break;
			case 12:
				$this->setEmail($value);
				break;
			case 13:
				$this->setSha1Password($value);
				break;
			case 14:
				$this->setSalt($value);
				break;
			case 15:
				$this->setCountry($value);
				break;
			case 16:
				$this->setLanguage($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UserPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNickname($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setFirstName($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setLastName($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setCreatedAt($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setBornAt($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setIsCoach($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setIsAthlete($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setCoachId($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setPictureId($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setIsAdmin($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setIsMale($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setEmail($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setSha1Password($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setSalt($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setCountry($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setLanguage($arr[$keys[16]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(UserPeer::DATABASE_NAME);

		if ($this->isColumnModified(UserPeer::ID)) $criteria->add(UserPeer::ID, $this->id);
		if ($this->isColumnModified(UserPeer::NICKNAME)) $criteria->add(UserPeer::NICKNAME, $this->nickname);
		if ($this->isColumnModified(UserPeer::FIRST_NAME)) $criteria->add(UserPeer::FIRST_NAME, $this->first_name);
		if ($this->isColumnModified(UserPeer::LAST_NAME)) $criteria->add(UserPeer::LAST_NAME, $this->last_name);
		if ($this->isColumnModified(UserPeer::CREATED_AT)) $criteria->add(UserPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(UserPeer::BORN_AT)) $criteria->add(UserPeer::BORN_AT, $this->born_at);
		if ($this->isColumnModified(UserPeer::IS_COACH)) $criteria->add(UserPeer::IS_COACH, $this->is_coach);
		if ($this->isColumnModified(UserPeer::IS_ATHLETE)) $criteria->add(UserPeer::IS_ATHLETE, $this->is_athlete);
		if ($this->isColumnModified(UserPeer::COACH_ID)) $criteria->add(UserPeer::COACH_ID, $this->coach_id);
		if ($this->isColumnModified(UserPeer::PICTURE_ID)) $criteria->add(UserPeer::PICTURE_ID, $this->picture_id);
		if ($this->isColumnModified(UserPeer::IS_ADMIN)) $criteria->add(UserPeer::IS_ADMIN, $this->is_admin);
		if ($this->isColumnModified(UserPeer::IS_MALE)) $criteria->add(UserPeer::IS_MALE, $this->is_male);
		if ($this->isColumnModified(UserPeer::EMAIL)) $criteria->add(UserPeer::EMAIL, $this->email);
		if ($this->isColumnModified(UserPeer::SHA1_PASSWORD)) $criteria->add(UserPeer::SHA1_PASSWORD, $this->sha1_password);
		if ($this->isColumnModified(UserPeer::SALT)) $criteria->add(UserPeer::SALT, $this->salt);
		if ($this->isColumnModified(UserPeer::COUNTRY)) $criteria->add(UserPeer::COUNTRY, $this->country);
		if ($this->isColumnModified(UserPeer::LANGUAGE)) $criteria->add(UserPeer::LANGUAGE, $this->language);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UserPeer::DATABASE_NAME);

		$criteria->add(UserPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNickname($this->nickname);

		$copyObj->setFirstName($this->first_name);

		$copyObj->setLastName($this->last_name);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setBornAt($this->born_at);

		$copyObj->setIsCoach($this->is_coach);

		$copyObj->setIsAthlete($this->is_athlete);

		$copyObj->setCoachId($this->coach_id);

		$copyObj->setPictureId($this->picture_id);

		$copyObj->setIsAdmin($this->is_admin);

		$copyObj->setIsMale($this->is_male);

		$copyObj->setEmail($this->email);

		$copyObj->setSha1Password($this->sha1_password);

		$copyObj->setSalt($this->salt);

		$copyObj->setCountry($this->country);

		$copyObj->setLanguage($this->language);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getFeedbackTypes() as $relObj) {
				$copyObj->addFeedbackType($relObj->copy($deepCopy));
			}

			foreach($this->getSeasons() as $relObj) {
				$copyObj->addSeason($relObj->copy($deepCopy));
			}

			foreach($this->getCompetitions() as $relObj) {
				$copyObj->addCompetition($relObj->copy($deepCopy));
			}

			foreach($this->getCompetitionCompetitors() as $relObj) {
				$copyObj->addCompetitionCompetitor($relObj->copy($deepCopy));
			}

			foreach($this->getUsersRelatedByCoachId() as $relObj) {
				if($this->getPrimaryKey() === $relObj->getPrimaryKey()) {
						continue;
				}

				$copyObj->addUserRelatedByCoachId($relObj->copy($deepCopy));
			}

			foreach($this->getArticles() as $relObj) {
				$copyObj->addArticle($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserPeer();
		}
		return self::$peer;
	}

	
	public function setUserRelatedByCoachId($v)
	{


		if ($v === null) {
			$this->setCoachId(NULL);
		} else {
			$this->setCoachId($v->getId());
		}


		$this->aUserRelatedByCoachId = $v;
	}


	
	public function getUserRelatedByCoachId($con = null)
	{
		if ($this->aUserRelatedByCoachId === null && ($this->coach_id !== null)) {
						include_once 'lib/model/om/BaseUserPeer.php';

			$this->aUserRelatedByCoachId = UserPeer::retrieveByPK($this->coach_id, $con);

			
		}
		return $this->aUserRelatedByCoachId;
	}

	
	public function setPicture($v)
	{


		if ($v === null) {
			$this->setPictureId(NULL);
		} else {
			$this->setPictureId($v->getId());
		}


		$this->aPicture = $v;
	}


	
	public function getPicture($con = null)
	{
		if ($this->aPicture === null && ($this->picture_id !== null)) {
						include_once 'lib/model/om/BasePicturePeer.php';

			$this->aPicture = PicturePeer::retrieveByPK($this->picture_id, $con);

			
		}
		return $this->aPicture;
	}

	
	public function initFeedbackTypes()
	{
		if ($this->collFeedbackTypes === null) {
			$this->collFeedbackTypes = array();
		}
	}

	
	public function getFeedbackTypes($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseFeedbackTypePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collFeedbackTypes === null) {
			if ($this->isNew()) {
			   $this->collFeedbackTypes = array();
			} else {

				$criteria->add(FeedbackTypePeer::COACH_ID, $this->getId());

				FeedbackTypePeer::addSelectColumns($criteria);
				$this->collFeedbackTypes = FeedbackTypePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(FeedbackTypePeer::COACH_ID, $this->getId());

				FeedbackTypePeer::addSelectColumns($criteria);
				if (!isset($this->lastFeedbackTypeCriteria) || !$this->lastFeedbackTypeCriteria->equals($criteria)) {
					$this->collFeedbackTypes = FeedbackTypePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFeedbackTypeCriteria = $criteria;
		return $this->collFeedbackTypes;
	}

	
	public function countFeedbackTypes($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseFeedbackTypePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(FeedbackTypePeer::COACH_ID, $this->getId());

		return FeedbackTypePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addFeedbackType(FeedbackType $l)
	{
		$this->collFeedbackTypes[] = $l;
		$l->setUser($this);
	}

	
	public function initSeasons()
	{
		if ($this->collSeasons === null) {
			$this->collSeasons = array();
		}
	}

	
	public function getSeasons($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSeasons === null) {
			if ($this->isNew()) {
			   $this->collSeasons = array();
			} else {

				$criteria->add(SeasonPeer::USER_ID, $this->getId());

				SeasonPeer::addSelectColumns($criteria);
				$this->collSeasons = SeasonPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SeasonPeer::USER_ID, $this->getId());

				SeasonPeer::addSelectColumns($criteria);
				if (!isset($this->lastSeasonCriteria) || !$this->lastSeasonCriteria->equals($criteria)) {
					$this->collSeasons = SeasonPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSeasonCriteria = $criteria;
		return $this->collSeasons;
	}

	
	public function countSeasons($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(SeasonPeer::USER_ID, $this->getId());

		return SeasonPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addSeason(Season $l)
	{
		$this->collSeasons[] = $l;
		$l->setUser($this);
	}

	
	public function initCompetitions()
	{
		if ($this->collCompetitions === null) {
			$this->collCompetitions = array();
		}
	}

	
	public function getCompetitions($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCompetitionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCompetitions === null) {
			if ($this->isNew()) {
			   $this->collCompetitions = array();
			} else {

				$criteria->add(CompetitionPeer::COACH_ID, $this->getId());

				CompetitionPeer::addSelectColumns($criteria);
				$this->collCompetitions = CompetitionPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CompetitionPeer::COACH_ID, $this->getId());

				CompetitionPeer::addSelectColumns($criteria);
				if (!isset($this->lastCompetitionCriteria) || !$this->lastCompetitionCriteria->equals($criteria)) {
					$this->collCompetitions = CompetitionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCompetitionCriteria = $criteria;
		return $this->collCompetitions;
	}

	
	public function countCompetitions($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseCompetitionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(CompetitionPeer::COACH_ID, $this->getId());

		return CompetitionPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addCompetition(Competition $l)
	{
		$this->collCompetitions[] = $l;
		$l->setUser($this);
	}

	
	public function initCompetitionCompetitors()
	{
		if ($this->collCompetitionCompetitors === null) {
			$this->collCompetitionCompetitors = array();
		}
	}

	
	public function getCompetitionCompetitors($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCompetitionCompetitorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCompetitionCompetitors === null) {
			if ($this->isNew()) {
			   $this->collCompetitionCompetitors = array();
			} else {

				$criteria->add(CompetitionCompetitorPeer::COMPETITOR_ID, $this->getId());

				CompetitionCompetitorPeer::addSelectColumns($criteria);
				$this->collCompetitionCompetitors = CompetitionCompetitorPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(CompetitionCompetitorPeer::COMPETITOR_ID, $this->getId());

				CompetitionCompetitorPeer::addSelectColumns($criteria);
				if (!isset($this->lastCompetitionCompetitorCriteria) || !$this->lastCompetitionCompetitorCriteria->equals($criteria)) {
					$this->collCompetitionCompetitors = CompetitionCompetitorPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCompetitionCompetitorCriteria = $criteria;
		return $this->collCompetitionCompetitors;
	}

	
	public function countCompetitionCompetitors($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseCompetitionCompetitorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(CompetitionCompetitorPeer::COMPETITOR_ID, $this->getId());

		return CompetitionCompetitorPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addCompetitionCompetitor(CompetitionCompetitor $l)
	{
		$this->collCompetitionCompetitors[] = $l;
		$l->setUser($this);
	}


	
	public function getCompetitionCompetitorsJoinCompetition($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseCompetitionCompetitorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collCompetitionCompetitors === null) {
			if ($this->isNew()) {
				$this->collCompetitionCompetitors = array();
			} else {

				$criteria->add(CompetitionCompetitorPeer::COMPETITOR_ID, $this->getId());

				$this->collCompetitionCompetitors = CompetitionCompetitorPeer::doSelectJoinCompetition($criteria, $con);
			}
		} else {
									
			$criteria->add(CompetitionCompetitorPeer::COMPETITOR_ID, $this->getId());

			if (!isset($this->lastCompetitionCompetitorCriteria) || !$this->lastCompetitionCompetitorCriteria->equals($criteria)) {
				$this->collCompetitionCompetitors = CompetitionCompetitorPeer::doSelectJoinCompetition($criteria, $con);
			}
		}
		$this->lastCompetitionCompetitorCriteria = $criteria;

		return $this->collCompetitionCompetitors;
	}

	
	public function initUsersRelatedByCoachId()
	{
		if ($this->collUsersRelatedByCoachId === null) {
			$this->collUsersRelatedByCoachId = array();
		}
	}

	
	public function getUsersRelatedByCoachId($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUsersRelatedByCoachId === null) {
			if ($this->isNew()) {
			   $this->collUsersRelatedByCoachId = array();
			} else {

				$criteria->add(UserPeer::COACH_ID, $this->getId());

				UserPeer::addSelectColumns($criteria);
				$this->collUsersRelatedByCoachId = UserPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(UserPeer::COACH_ID, $this->getId());

				UserPeer::addSelectColumns($criteria);
				if (!isset($this->lastUserRelatedByCoachIdCriteria) || !$this->lastUserRelatedByCoachIdCriteria->equals($criteria)) {
					$this->collUsersRelatedByCoachId = UserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserRelatedByCoachIdCriteria = $criteria;
		return $this->collUsersRelatedByCoachId;
	}

	
	public function countUsersRelatedByCoachId($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(UserPeer::COACH_ID, $this->getId());

		return UserPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addUserRelatedByCoachId(User $l)
	{
		$this->collUsersRelatedByCoachId[] = $l;
		$l->setUserRelatedByCoachId($this);
	}


	
	public function getUsersRelatedByCoachIdJoinPicture($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUsersRelatedByCoachId === null) {
			if ($this->isNew()) {
				$this->collUsersRelatedByCoachId = array();
			} else {

				$criteria->add(UserPeer::COACH_ID, $this->getId());

				$this->collUsersRelatedByCoachId = UserPeer::doSelectJoinPicture($criteria, $con);
			}
		} else {
									
			$criteria->add(UserPeer::COACH_ID, $this->getId());

			if (!isset($this->lastUserRelatedByCoachIdCriteria) || !$this->lastUserRelatedByCoachIdCriteria->equals($criteria)) {
				$this->collUsersRelatedByCoachId = UserPeer::doSelectJoinPicture($criteria, $con);
			}
		}
		$this->lastUserRelatedByCoachIdCriteria = $criteria;

		return $this->collUsersRelatedByCoachId;
	}

	
	public function initArticles()
	{
		if ($this->collArticles === null) {
			$this->collArticles = array();
		}
	}

	
	public function getArticles($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArticlePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArticles === null) {
			if ($this->isNew()) {
			   $this->collArticles = array();
			} else {

				$criteria->add(ArticlePeer::AUTHOR_ID, $this->getId());

				ArticlePeer::addSelectColumns($criteria);
				$this->collArticles = ArticlePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ArticlePeer::AUTHOR_ID, $this->getId());

				ArticlePeer::addSelectColumns($criteria);
				if (!isset($this->lastArticleCriteria) || !$this->lastArticleCriteria->equals($criteria)) {
					$this->collArticles = ArticlePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastArticleCriteria = $criteria;
		return $this->collArticles;
	}

	
	public function countArticles($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseArticlePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ArticlePeer::AUTHOR_ID, $this->getId());

		return ArticlePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addArticle(Article $l)
	{
		$this->collArticles[] = $l;
		$l->setUser($this);
	}

} 